
package de.ivu.elect.presentation.ergebnis.exchange;

import java.util.Collection;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.dokumente.control.ElectDokumentContext;
import de.ivu.elect.business.ergebnis.control.NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.exchange.control.FileFormat;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.system.boundary.NlSpecialBackgroundServiceRunning;
import de.ivu.elect.business.wahl.boundary.NlExportArtefaktNachSystemExportstatusBulkExporter;
import de.ivu.elect.business.wahl.control.AbstractNlExportArtefaktNachSystemExportstatusExportContext;
import de.ivu.elect.business.wahl.entity.AbstractWahlParameterLoader;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;

@OnlineHilfeId("TODO")
@Named(NlWasErgebnisArtefaktNachGebietFreigabeBulkExportView.COMPONENT_NAME)
@View(viewId = NlWasErgebnisArtefaktNachGebietFreigabeBulkExportView.VIEW_ID, useCase = UseCasePermission.GEBIET_ERGEBNISEINGABESTATUS_SETZEN_FREIGEGEBEN)
public class NlWasErgebnisArtefaktNachGebietFreigabeBulkExportView extends AbstractNlWasErgebnisArtefaktNachGebietErgebniseingabestatusBulkExportView {

  public static final String COMPONENT_NAME = "nlWasErgebnisArtefaktNachGebietFreigabeBulkExportView";

  public static final String VIEW_ID = "/ergebnis/nl-ergebnisdokument-nach-gebiet-freigabe-bulk-export.xhtml";

  private static final long serialVersionUID = 1L;

  @Inject
  private transient NlExportArtefaktNachSystemExportstatusBulkExporter nlExportArtefaktNachSystemExportstatusBulkExporter;

  @Inject
  private transient NlWasErgebnisArtefaktNachGebietFreigabeBulkExportDescription nlWasErgebnisArtefaktNachGebietFreigabeBulkExportDescription;

  @Inject
  private transient NlSpecialBackgroundServiceRunning nlSpecialBackgroundServiceRunning;

  private boolean isGlobalReadOnlyModus = false;

  public NlWasErgebnisArtefaktNachGebietFreigabeBulkExportView() {
    super();
  }

  @Override
  public String getPageTitle() {
    String msgKey = "ergebnisdokument.nach.gebiet.freigabe.export.page.title";

    if (NlWahlart.EERSTE_KAMER.equalsWahlart(getSelectedWahl())) {
      msgKey += ".EERSTE_KAMER"; // ELECT-13517
    }

    return getMessage(msgKey);
  }

  @Override
  public String getPageHeader() {
    String msgKey = "ergebnisdokument.nach.gebiet.freigabe.export.page.header";

    if (NlWahlart.EERSTE_KAMER.equalsWahlart(getSelectedWahl())) {
      msgKey += ".EERSTE_KAMER"; // ELECT-13517
    }

    return getMessage(msgKey);
  }

  @Override
  public NlWasErgebnisArtefaktNachGebietFreigabeBulkExportDescription getExportDescription() {
    return nlWasErgebnisArtefaktNachGebietFreigabeBulkExportDescription;
  }

  @Override
  protected NlExportArtefaktNachSystemExportstatusBulkExporter getExporter() {
    return nlExportArtefaktNachSystemExportstatusBulkExporter;
  }

  @Override
  protected NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext createContext(ElectDokumentContext electDokumentContext, AbstractWahlParameterLoader wahlParameterLoader,
      Collection<Gebiet> gebieteInWahl, Ergebnis ergebnis) {
    return new NlWasErgebnisArtefaktNachGebietErgebniseingabestatusExportContext(electDokumentContext, wahlParameterLoader, gebieteInWahl, ergebnis,
        getExportDescription().getErgebniseingabestatusExported());
  }

  @Override
  public boolean isBtnExportierenDisabled() {
    return super.isBtnExportierenDisabled() || ergebnisberechnungLaeuft() || isGlobalReadOnlyModus;
  }

  @Override
  protected void addProperties(FormBuilder formBuilder, FileFormat fileFormat, AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    super.addProperties(formBuilder, fileFormat, context);
    if (isBtnExportierenDisabled()) {
      formBuilder.globalReadonly();
      this.isGlobalReadOnlyModus = true;
    }
  }

  @Override
  public void preRenderView() {
    super.preRenderView();
    if (isBtnExportierenDisabled()) {
      messages.addWarnMessage("nl.hintergrundprozess.laeuft.noch.warnung");
    }
  }

  @Redirect
  public String aktualisieren() {
    reset();
    isGlobalReadOnlyModus = ergebnisberechnungLaeuft();
    return VIEW_ID;
  }

  public String getBtnAktualisierenStyle() {
    if (isBtnExportierenDisabled()) {
      return "";
    }
    //den Knopf zum Aktualisieren nur anzeigen, wenn den zum Generieren deaktiviert ist.
    return "display: none";
  }

  private boolean ergebnisberechnungLaeuft() {
    return nlSpecialBackgroundServiceRunning.isSomethingRunning();
  }
}
